/*
* License:  This  program  is  free  software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as published by
* the  Free Software Foundation; either version 3 of the License, or (at your
* option)  any later version. This program is distributed in the hope that it
* will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
* of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
* 
* Code home:
* 	www.funkboxing.com
* 	http://funkboxing.com/wordpress/?p=2154
* 
* This project was a very helpful reference: 
* 	http://uzzors2k.4hv.org/index.php?page=blucar
*/

package com.funkboxing.led_controller;

import java.io.IOException;
import java.io.OutputStream;
import java.util.List;
import java.util.UUID;

import com.funkboxing.led_controller.R;

//import com.teldredge.btremote.R;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnClickListener;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Spinner;
import android.widget.Toast;
import android.graphics.Color;

public class led_controller extends Activity{
	
	//---REQUEST CODES
    private static final int REQUEST_CONNECT_DEVICE = 1;
    private static final int REQUEST_ENABLE_BT = 2;
    
    //---PROGRAM VARS
    private byte AttinyOut;
    private boolean GyroXModeStatus;
    private boolean GyroYModeStatus;    
    private boolean AudioModeStatus;
    private boolean connectStat = false;    
    
    private Button mButton1;
    private Button mButton2;
    private Button mButton3;
    private Button mButton4;
    private Button mButton5;
    private Button mButton6;
    
    private TextView xDebugText0; 
    private TextView xDebugText1;
    private TextView xDebugText2;
    private TextView xDebugText3;
    
    protected static final int MOVE_TIME = 80;
    private long lastWrite = 0;
    private AlertDialog aboutAlert;
    private View aboutView;
    private View controlView;
    OnClickListener myClickListener;
    ProgressDialog myProgressDialog;
    private Toast failToast;
    private Handler mHandler;
    
    //---SENSOR/ACCELEROMETER STUFF
    private SensorManager mySensorManager; 
    private List<Sensor> sensors; 
    private Sensor accSensor;
    
	//---BLUETOOTH VARS AND STUFF
    private BluetoothAdapter mBluetoothAdapter = null;
    private BluetoothSocket btSocket = null; 
    private OutputStream outStream = null;
    private ConnectThread mConnectThread = null;
    private String deviceAddress = null;
    // Well known SPP UUID (will *probably* map to RFCOMM channel 1 (default) if not in use); 
    private static final UUID SPP_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
    
    //---SERIAL ARDUINO COMMANDS
    private String serialCommandString = null;
    private String strOut = null;
    private byte[] serialCommandBytes;
    
    private TextView mTextView1;
    private TextView mTextView2;
    private TextView mTextView3;
    private TextView mTextView4;
    private TextView mTextView5;
    
    private SeekBar mSeekBar1;
  	private SeekBar mSeekBar2;
  	private SeekBar mSeekBar3;
  	private SeekBar mSeekBar4;
  	private SeekBar mSeekBar5;
  	
  	private Spinner mSpinner1;
  	
  	//private long speedVar;
  	//private int delayVar;
  	long timestampA = 00L;
  	long timestampB = System.currentTimeMillis();
  	long timepassed = timestampB - timestampA;
  	
    // Toast variable in order to prevent overloading
  	private Toast mCurrentToast = null;   
        
     /** Called when the activity is first created. */ 
     @Override 
     public void onCreate(Bundle savedInstanceState) { 
    	 super.onCreate(savedInstanceState);

    	 //---TEST SPEED OF DEVICE, DETERMINE DELAY VAR (KIND OF HACKY)
    	 //long beginTime = System.currentTimeMillis();
    	 //for(int i = 0; i < 5000000; i = i+1) {
    		 //long throwaway = 22/7;
    	 //}
    	 //long endTime = System.currentTimeMillis();
    	 //speedVar = endTime - beginTime;
    	 //delayVar = (int) (10/speedVar)*10;
    	 //String diffString = Long.toString(diff);
    	 //Toast.makeText(getApplicationContext(), diffString, Toast.LENGTH_LONG).show();    	 
    	 
    	 //---SETUP MAIN WINDOW VIEW
    	 LayoutInflater inflater = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    	 aboutView = inflater.inflate(R.layout.aboutview, null);
    	 controlView = inflater.inflate(R.layout.main, null);
    	 controlView.setKeepScreenOn(true);
    	 setContentView(controlView);
    	 
         //---SETUP UI WIDGETS
         mButton1 = (Button) findViewById(R.id.button1);
         mButton2 = (Button) findViewById(R.id.button2);
         mButton3 = (Button) findViewById(R.id.button3);
         mButton4 = (Button) findViewById(R.id.button4);
         mButton5 = (Button) findViewById(R.id.button5);
         mButton6 = (Button) findViewById(R.id.button6);
         
         xDebugText0 = (TextView) findViewById(R.id.debugText0);
         xDebugText1 = (TextView) findViewById(R.id.debugText1);
         xDebugText2 = (TextView) findViewById(R.id.debugText2);
         xDebugText3 = (TextView) findViewById(R.id.debugText3);         

         mTextView1 = (TextView) findViewById(R.id.textView1);
         mTextView2 = (TextView) findViewById(R.id.textView2);
         mTextView3 = (TextView) findViewById(R.id.textView3);
         mTextView4 = (TextView) findViewById(R.id.textView4);
         mTextView5 = (TextView) findViewById(R.id.textView5);
         
         mSeekBar1 = (SeekBar) findViewById(R.id.seekBar1); //-delay
         mSeekBar2 = (SeekBar) findViewById(R.id.seekBar2); //-step         
         mSeekBar3 = (SeekBar) findViewById(R.id.seekBar3); //-hue
         mSeekBar4 = (SeekBar) findViewById(R.id.seekBar4); //-saturation
         mSeekBar5 = (SeekBar) findViewById(R.id.seekBar5); //-brightness
         
         mSpinner1 = (Spinner) findViewById(R.id.spinner1);
         
         mSeekBar1.setMax(100);
         mSeekBar2.setMax(50);
         mSeekBar3.setMax(255);
         mSeekBar4.setMax(255);
         mSeekBar5.setMax(255);
         
         mSeekBar1.setProgress(20);
         mSeekBar2.setProgress(10);
         mSeekBar3.setProgress(0);
         mSeekBar4.setProgress(255);
         mSeekBar5.setProgress(64);


         
         //---CONNECT TO BLUETOOTH MODULE
         mButton1.setOnClickListener(new View.OnClickListener() {
 			@Override
 			public void onClick(View v) {
				if (connectStat) {disconnect();}					
				else{connect();}				
 			}
 		});         
         
         //---SELECT LEF FX MODE BASED ON SPINNER SELECTION
         mButton2.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				xDebugText1.setText("mode"+mSpinner1.getSelectedItemPosition());
				serialCommandString = "m"+mSpinner1.getSelectedItemPosition();
				serialCommandBytes = serialCommandString.getBytes();
				write2(serialCommandBytes);
			}
		});         
         
         //---TEST BUTTON X
         //---TOGGLE GYROMODE - X
         mButton3.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				//xDebugText1.setText("YOUWORD");
				//Toast.makeText(getApplicationContext(), "CLICK", Toast.LENGTH_LONG).show();
				if (GyroXModeStatus) {
					mButton3.setText(R.string.GyroXModeOFF);
					GyroXModeStatus = false;					
				}else{
					mButton3.setText(R.string.GyroXModeON);
					GyroXModeStatus = true;
				}
			}
		});
         
       //---TEST BUTTON Y
       //---TOGGLE GYROMODE - Y
         mButton4.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				if (GyroYModeStatus) {
					mButton4.setText(R.string.GyroYModeOFF);
					GyroYModeStatus = false;					
				}else{
					mButton4.setText(R.string.GyroYModeON);
					GyroYModeStatus = true;
				}
			}
		});         


         //---TEST BUTTON Z
         //---TESTING INDEXING LED'S INDIVIDUALLY
         mButton5.setOnTouchListener(new View.OnTouchListener() {
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				if ((event.getAction() == MotionEvent.ACTION_DOWN) | (event.getAction() == MotionEvent.ACTION_MOVE)) {
					int h = 0; 
					float[] thisHSV = new float[3];
					thisHSV[0] = 0;		//Hue (0 .. 360) 
					thisHSV[1] = 1;		//Saturation (0...1) 
					thisHSV[2] = 1;		//Value (0...1)
						for(int i = 0; i < 23; i = i+1) {
							//ADD MILLIS DELAY HERE
							//timestampB = System.currentTimeMillis();
							//timepassed = timestampB - timestampA; 
							//if (timepassed > x){
							//timestampA = System.currentTimeMillis();
							thisHSV[0] = thisHSV[0] + 10;
							String st_i = Integer.toString(i);
							int thisRGB = Color.HSVToColor(thisHSV);
							String thisR = Integer.toString(Color.red(thisRGB));
							String thisG = Integer.toString(Color.green(thisRGB));
							String thisB = Integer.toString(Color.blue(thisRGB));
							strOut = "l" + st_i
									+ "," + thisR
									+ "," + thisG
									+ "," + thisB + ";";
							xDebugText1.setText(strOut);
							serialCommandBytes = strOut.getBytes();
							write2(serialCommandBytes);
							
							// SLEEP/DELAY
					        //try {
					        //    Thread.sleep(delayVar);
					        //} catch (InterruptedException e) {
					            //e.printStackTrace();
					        //}
							
			  				// SEND SHOW STRIP COMMAND
			  				serialCommandString = "z;";  				
			  				serialCommandBytes = serialCommandString.getBytes();
							write2(serialCommandBytes);
						}

					return true;
					
				}else if (event.getAction() == MotionEvent.ACTION_UP) {
					mButton5.setPressed(false);
					return true;
				}
				mButton5.setPressed(false);
				return false;
			}
		});         

         //---TEST BUTTON Q
         //---TOGGLE AUDIOMODE
           mButton6.setOnClickListener(new View.OnClickListener() {
  			@Override
  			public void onClick(View v) {
  				//String diffString = Long.toString(speedVar) + "," + Long.toString(delayVar);
  				//Toast.makeText(getApplicationContext(), diffString, Toast.LENGTH_LONG).show();
  				
  				//MediaRecorder.getMaxAmplitude()
  				
  				if (AudioModeStatus) {
  					mButton6.setText(R.string.AudioModeOFF);
  					AudioModeStatus = false;					
  				}else{
  					mButton6.setText(R.string.AudioModeON);
  					AudioModeStatus = true;
  				}
  			}
  		});         
         

           
           
           
           
         //---SEEKBAR1 - DELAY
         mSeekBar1.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
	            public void onStopTrackingTouch(SeekBar bar) {}
	            public void onStartTrackingTouch(SeekBar bar) {}
	            public void onProgressChanged(SeekBar bar, int paramInt, boolean paramBoolean) {
	            	if(mSeekBar1.getProgress() < 1) {
	            		mSeekBar1.setProgress(1);
	            		paramInt = mSeekBar1.getProgress();} 
	            	serialCommandString = "d"+paramInt;
					mTextView1.setText(serialCommandString); //FUBAR if NULL
	            	serialCommandBytes = serialCommandString.getBytes();
					write2(serialCommandBytes);	            	 
	            }
         });
         
         //---SEEKBAR2 - STEP
         mSeekBar2.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
	            public void onStopTrackingTouch(SeekBar bar) {}
	            public void onStartTrackingTouch(SeekBar bar) {}
	            public void onProgressChanged(SeekBar bar, int paramInt, boolean paramBoolean) {
	            	if(mSeekBar2.getProgress() < 1) {
	            		mSeekBar2.setProgress(1);
	            		paramInt = mSeekBar2.getProgress();}	            	
					serialCommandString = "s"+paramInt;
					mTextView2.setText(serialCommandString); //FUBAR if NULL
					serialCommandBytes = serialCommandString.getBytes();
					write2(serialCommandBytes);
	            }
         });
         
         //---SEEKBAR3 - HUE
         mSeekBar3.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
	            public void onStopTrackingTouch(SeekBar bar) {}
	            public void onStartTrackingTouch(SeekBar bar) {}
	            public void onProgressChanged(SeekBar bar, int paramInt, boolean paramBoolean) {
					serialCommandString = "h"+paramInt;
					mTextView3.setText(serialCommandString); //FUBAR if NULL
					serialCommandBytes = serialCommandString.getBytes();
					write2(serialCommandBytes);
	            }
         });
         
         //---SEEKBAR4 - SATURATION
         mSeekBar4.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
	            public void onStopTrackingTouch(SeekBar bar) {}
	            public void onStartTrackingTouch(SeekBar bar) {}
	            public void onProgressChanged(SeekBar bar, int paramInt, boolean paramBoolean) {
					serialCommandString = "t"+paramInt;
					mTextView4.setText(serialCommandString); //FUBAR if NULL
					serialCommandBytes = serialCommandString.getBytes();
					write2(serialCommandBytes);
	            }
         });

         //---SEEKBAR5 - BRIGHTNESS
         mSeekBar5.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
	            public void onStopTrackingTouch(SeekBar bar) {}
	            public void onStartTrackingTouch(SeekBar bar) {}
	            public void onProgressChanged(SeekBar bar, int paramInt, boolean paramBoolean) {
					serialCommandString = "b"+paramInt;
					mTextView5.setText(serialCommandString); //FUBAR if NULL
					serialCommandBytes = serialCommandString.getBytes();
					write2(serialCommandBytes);	            	
	            		            	            	
	            }
         }); 	    


         //---SETUP SENSOR - ACCELEROMETER
         mySensorManager = (SensorManager)getSystemService(Context.SENSOR_SERVICE); 
         sensors = mySensorManager.getSensorList(Sensor.TYPE_ACCELEROMETER); 
         if(sensors.size() > 0) accSensor = sensors.get(0); 


         //---HELP AND INFO DIALOG CLICK HANDLER
         myClickListener = new DialogInterface.OnClickListener() {
    			@Override
    			public void onClick(DialogInterface dialog, int which) {
    				switch (which) {
    				case DialogInterface.BUTTON_POSITIVE:
    					dialog.dismiss();
    				break;
    				case DialogInterface.BUTTON_NEUTRAL:
    					// Display website
    					Intent browserIntent = new Intent("android.intent.action.VIEW", Uri.parse(getResources().getString(R.string.website_url)));
						startActivity(browserIntent);
    				break;
    				default: dialog.dismiss();
    				}
    			}
         };
         

         myProgressDialog = new ProgressDialog(this);
         failToast = Toast.makeText(this, R.string.failedToConnect, Toast.LENGTH_SHORT);
         
         mHandler = new Handler() {
             @Override
             public void handleMessage(Message msg) {
            	 if (myProgressDialog.isShowing()) {
                 	myProgressDialog.dismiss();
                 }
            	 
            	 //---CHECK IF BLUETOOTH CONNECTED
                 if (msg.what == 1) {
                 	//---SET BUTTON TO SHOW CONNECTION STATUS
                     connectStat = true;
                     mButton1.setText(R.string.connected);
                     
         	 		//---RESET ALL
         	 		AttinyOut = 0;
         	 		GyroXModeStatus = false;
         	 		GyroYModeStatus = false;
         	 		write(AttinyOut);
                 }else {
                 	//---CONNECTION FAILED
                	 failToast.show();
                 }
             }
         };
         
         //---ABOUT DIALOG
         AlertDialog.Builder builder = new AlertDialog.Builder(this);
         builder.setView(aboutView).setCancelable(true).setTitle(getResources().getString(R.string.app_name) + " " + getResources().getString(R.string.appVersion)).setIcon(R.drawable.ledicon_4848_mdpi).setPositiveButton(getResources().getString(R.string.okButton), myClickListener).setNeutralButton(getResources().getString(R.string.websiteButton), myClickListener);
         aboutAlert = builder.create();
         
         //---CHECK IF BT ADAPTER EXISTS
         mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter(); 
         if (mBluetoothAdapter == null) { 
              Toast.makeText(this, R.string.no_bt_device, Toast.LENGTH_LONG).show(); 
              finish(); 
              return; 
         } 
         
         //---IF BT NOT ON, ENABLE
         if (!mBluetoothAdapter.isEnabled()) {
             Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
             startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
         }
         

     }
     
     /** Thread used to connect to a specified Bluetooth Device */
     public class ConnectThread extends Thread {
    	private String address;
    	private boolean connectionStatus;
    	
		ConnectThread(String MACaddress) {
			address = MACaddress;
			connectionStatus = true;
    	}
		
		public void run() {
			try {
				BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
	            try { 
	                 btSocket = device.createRfcommSocketToServiceRecord(SPP_UUID); 
	            } catch (IOException e) { 
	            	connectionStatus = false;
	            } 
			}catch (IllegalArgumentException e) {
				connectionStatus = false;
			}
            mBluetoothAdapter.cancelDiscovery(); 
            try {
                 btSocket.connect(); 
            } catch (IOException e1) {
                 try {
                      btSocket.close(); 
                 } catch (IOException e2) {
                 }
            }
            try { 
            	outStream = btSocket.getOutputStream(); 
            } catch (IOException e2) {
            	connectionStatus = false;
            }
            if (connectionStatus) {
            	mHandler.sendEmptyMessage(1);
            }else {
            	mHandler.sendEmptyMessage(0);
            }
		}
     }
     
     public void onActivityResult(int requestCode, int resultCode, Intent data) {
    	 switch (requestCode) {
         case REQUEST_CONNECT_DEVICE:
        	 // When DeviceListActivity returns with a device to connect
             if (resultCode == Activity.RESULT_OK) {
            	// Show please wait dialog
 				myProgressDialog = ProgressDialog.show(this, getResources().getString(R.string.pleaseWait), getResources().getString(R.string.makingConnectionString), true);
 				
            	// Get the device MAC address
        		deviceAddress = data.getExtras().getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
        		// Connect to device with specified MAC address
                mConnectThread = new ConnectThread(deviceAddress);
                mConnectThread.start();
                
             }else {
            	 // Failure retrieving MAC address
            	 Toast.makeText(this, R.string.macFailed, Toast.LENGTH_SHORT).show();
             }
             break;
         case REQUEST_ENABLE_BT:
             // When the request to enable Bluetooth returns
             if (resultCode == Activity.RESULT_OK) {
                 // Bluetooth is now enabled
             } else {
                 // User did not enable Bluetooth or an error occured
                 Toast.makeText(this, R.string.bt_not_enabled_leaving, Toast.LENGTH_SHORT).show();
                 finish();
             }
         }
     }
     
     public void write(byte data) {
    	 if (outStream != null) {
             try {
            	 outStream.write(data);
             } catch (IOException e) {
             }
         }
     }
     
     public void write2(byte[] data) {
    	 if (outStream != null) {
             try {
            	 outStream.write(data);
             } catch (IOException e) {
             }
         }
     }
          
     public void emptyOutStream() {
    	 if (outStream != null) {
             try {
            	 outStream.flush();
             } catch (IOException e) {
             }
         }
     }
     
     public void connect() {
    	 // Launch the DeviceListActivity to see devices and do scan
         Intent serverIntent = new Intent(this, DeviceListActivity.class);
         startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
     }
     
     public void disconnect() {
    	 if (outStream != null) {
    		 try {
    	 			outStream.close();
    	 			connectStat = false;
    				mButton1.setText(R.string.disconnected);
    	 		} catch (IOException e) {
    	 		}
    	 } 
     }
     
     
     //---GYRO MODE - X AXIS
     private final SensorEventListener mSensorListener = new SensorEventListener() {

    	 @Override
    	 public void onAccuracyChanged(Sensor sensor, int accuracy) {}
  		
    	 @Override
    	 public void onSensorChanged(SensorEvent event) {
  			// Checks whether to send steering command or not
  			//long date = System.currentTimeMillis();
  			//if (date - lastWrite > MOVE_TIME) {
  			if (GyroXModeStatus){
  				//---SEND CLEAR STRIP COMMAND
  				serialCommandString = "c;" ;  				
  				serialCommandBytes = serialCommandString.getBytes();
				write2(serialCommandBytes);
				
				//---GET INDEX OF LED FOR GYRO-X MODE
  				int roundXAcc = (int)event.values[0] + 11;
  				xDebugText2.setText("Xraw:" + event.values[0]);
  				xDebugText3.setText("Xout:" + roundXAcc);
				
  				//---SEND SET LED COMMAND
  				serialCommandString = "l"+roundXAcc+",255,0,0;";
				serialCommandBytes = serialCommandString.getBytes();
				write2(serialCommandBytes);
				
  				//---SEND SHOW STRIP COMMAND
  				serialCommandString = "z;";  				
  				serialCommandBytes = serialCommandString.getBytes();
				write2(serialCommandBytes);				
  			}
  			if (GyroYModeStatus){
				//---GET Y VAL, CONVERT TO HUE (VAL VETWEEN 0-255)
  				int roundYAcc = Math.abs((int)(event.values[1] / 10 * 255));
  				xDebugText0.setText("Yraw:" + event.values[1]);
  				xDebugText1.setText("Yout:" + roundYAcc);

  				//---SEND SET LED COMMAND
  				serialCommandString = "a"+roundYAcc + ";";
				serialCommandBytes = serialCommandString.getBytes();
				write2(serialCommandBytes);  				
  				
  				//---SEND SHOW STRIP COMMAND
  				serialCommandString = "z;";  				
  				serialCommandBytes = serialCommandString.getBytes();
				write2(serialCommandBytes);	
  			}
    	 }
     };
       

     
     @Override
     public boolean onCreateOptionsMenu(Menu menu) {
         MenuInflater inflater = getMenuInflater();
         inflater.inflate(R.menu.option_menu, menu);
         return true;
     }
     
     @Override
     public boolean onOptionsItemSelected(MenuItem item) {
         switch (item.getItemId()) {
         case R.id.about:
             // Show info about the author (that's me!)
        	 aboutAlert.show();
             return true;
         }
         return false;
     }

     @Override 
     public void onResume() { 
          super.onResume();
          mySensorManager.registerListener(mSensorListener, accSensor, SensorManager.SENSOR_DELAY_GAME);
     } 

     @Override 
     public void onDestroy() { 
    	 emptyOutStream();
         disconnect();
         if (mSensorListener != null) {
        	 mySensorManager.unregisterListener(mSensorListener);
         }
         super.onDestroy(); 
     } 
}